"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const cx = require("classnames");
const illuminate_js_1 = require("illuminate-js");
const Token_1 = require("./Token");
class Illuminate extends React.PureComponent {
    renderLineNumbers(code) {
        const match = code.match(/\n(?!$)/g);
        const linesNum = match ? match.length + 1 : 1;
        let lines = [];
        for (let i = 0; i < linesNum; i++) {
            lines.push(React.createElement("span", { key: `line-${i}`, className: "line-number" }));
        }
        return React.createElement("span", { className: "line-numbers-rows" }, lines);
    }
    render() {
        const { lang, children } = this.props;
        let token = children;
        const grammar = illuminate_js_1.getLanguage(lang || '');
        if (!grammar) {
            return children;
        }
        token = illuminate_js_1.tokenize(children, grammar);
        const className = cx(`language-${lang}`, {
            'line-numbers': this.props.lineNumbers,
            'show-language': this.props.showLanguage
        });
        return (React.createElement("pre", { className: className },
            React.createElement("code", null,
                this.props.showLanguage && React.createElement("span", { className: "show-language--lang" }, lang),
                React.createElement(Token_1.TokenElement, { customClasses: this.props.customClasses, token: token }),
                this.props.lineNumbers && this.renderLineNumbers(children))));
    }
}
exports.Illuminate = Illuminate;
